using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace WindowsApplication30
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			this.gridControl1.ResetVolatileData();
			this.gridControl1.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(gridControlTable_QueryCellInfo);
			this.gridControl1.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControlTable_QueryRowCount);
			this.gridControl1.QueryColCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControlTable_QueryColCount);
			this.gridControl1.QueryColWidth += new Syncfusion.Windows.Forms.Grid.GridRowColSizeEventHandler(gridControlTable_QueryColWidth);
            this.gridControl1.Model.Options.ResizeRowsBehavior = GridResizeCellsBehavior.ResizeAll | GridResizeCellsBehavior.OutlineBounds;
		}

		void gridControlTable_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if (/*e.RowIndex > 0 &&*/ e.ColIndex > 0)
			{
				e.Style.CellValue = "asdf";
//				e.Style.CellValue = this.Engine.GetCellString(e.RowIndex, e.ColIndex - 1);
				e.Handled = true;
			}
		}

		void gridControlTable_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = 500000; //should return 0 if no database connected
			e.Handled = true;
		}

		void gridControlTable_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = 9;
			e.Handled = true;
		}

		void gridControlTable_QueryColWidth(object sender, Syncfusion.Windows.Forms.Grid.GridRowColSizeEventArgs e)
		{
			if (e.Index > 0)
			{
				e.Size = 100;
				e.Handled = true;
			}
		}
	}

    public class DerivedGridControl : GridControl
    {
        /// <override/>
        public override int RowIndexToVScrollPixelPos(int rowIndex)
        {
            // Taking separate height for column headers into account.
            rowIndex = Math.Min(rowIndex, Model.RowCount);
            if (rowIndex > 0)
                return (rowIndex - 1) * Model.Rows.DefaultSize + Model.RowHeights[0];
            else
                return Model.RowHeights[0];
        }

        /// <override/>
        public override int GetVScrollPixelHeight()
        {
            if (Model.RowCount == 0)
                return 0;

            return (Model.RowCount - 1) * Model.Rows.DefaultSize + Model.RowHeights[0];
        }

        /// <override/>
        public override void VScrollPixelPosToRowIndex(int pixelPos, out int rowIndex, out int pixelDelta)
        {
            if (pixelPos < pixelPos - Model.RowHeights[0])
            {
                rowIndex = 0;
                pixelDelta = pixelPos;
            }
            rowIndex = (pixelPos - Model.RowHeights[0]) / Model.Rows.DefaultSize + 1;
            pixelDelta = (pixelPos -  Model.RowHeights[0]) % Model.Rows.DefaultSize;
        }
    }
}